Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Edge3DTest.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Edge3DTest.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Edge3DTest.cs	(revision 15554)
@@ -0,0 +1,117 @@
+﻿using System;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.BinPacking3D.Geometry;
+
+namespace HeuristicLab.Problems.BinPacking._3D.Geometry.Test {
+  [TestClass]
+  public class Edge3DTest {
+
+    Edge3D _edge1;
+    Edge3D _edge2;
+    Edge3D _edge3;
+    Edge3D _edge4;
+    Edge3D _edge5;
+    Edge3D _edge6;
+    Edge3D _edge7;
+    Edge3D _edge8;
+    Edge3D _edge9;
+
+    Vector3D _point1;
+    Vector3D _point2;
+    Vector3D _point3;
+    Vector3D _point4;
+    Vector3D _point5;
+    Vector3D _point6;
+
+    [TestInitialize]
+    public void Initialize() {
+      _edge1 = new Edge3D(new Vector3D(0, 0, 0), new Vector3D(10, 0, 0));
+      _edge2 = new Edge3D(new Vector3D(0, 0, 0), new Vector3D(0, 10, 0));
+      _edge3 = new Edge3D(new Vector3D(0, 0, 0), new Vector3D(0, 0, 10));
+
+      _edge4 = new Edge3D(new Vector3D(-10, 2, 2), new Vector3D(10, 2, 2));
+      _edge5 = new Edge3D(new Vector3D(2, -10, 2), new Vector3D(2, 10, 2));
+      _edge6 = new Edge3D(new Vector3D(2, 2, -10), new Vector3D(2, 2, 10));
+
+      _edge7 = new Edge3D(new Vector3D(-10, 5, 5), new Vector3D(10, 5, 5));
+      _edge8 = new Edge3D(new Vector3D(5, -10, 5), new Vector3D(5, 10, 5));
+      _edge9 = new Edge3D(new Vector3D(5, 5, -10), new Vector3D(5, 5, 10));
+
+      _point1 = new Vector3D(3, 0, 0);
+      _point2 = new Vector3D(0, 3, 0);
+      _point3 = new Vector3D(0, 0, 3);
+
+      _point4 = new Vector3D(5, 5, 5);
+      _point5 = new Vector3D(2, 2, 2);
+      _point6 = new Vector3D(0, 0, 0);
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestConstructors() {
+      var e1 = new Edge3D() {
+        Start = new Vector3D(10, 0, 0),
+        End = new Vector3D(10, 5, 0)
+      };
+      var e2 = new Edge3D(new Vector3D(10, 0, 0), new Vector3D(10, 5, 0));
+      var e3 = new Edge3D(new BinPacking3D.PackingPosition(0, 10, 0, 0), new BinPacking3D.PackingPosition(0, 10, 5, 0));
+
+      Assert.AreEqual(e1.Start, e2.Start);
+      Assert.AreEqual(e1.End, e2.End);
+      Assert.AreEqual(e1.Start, e3.Start);
+      Assert.AreEqual(e1.End, e3.End);
+      Assert.AreEqual(e3.Start, e2.Start);
+      Assert.AreEqual(e3.End, e2.End);
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestLiesOn() {
+      Assert.IsTrue(_edge1.LiesOn(_point1));
+      Assert.IsFalse(_edge1.LiesOn(_point4));
+      Assert.IsTrue(_edge3.LiesOn(_point6));
+      Assert.IsFalse(_edge2.LiesOn(_point5));
+      Assert.IsTrue(_edge4.LiesOn(_point5));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestIntersects() {
+      Assert.IsNull(_edge1.Intersects(_edge4));
+      Assert.IsNull(_edge4.Intersects(_edge1));
+      Assert.IsNull(_edge7.Intersects(_edge5));
+      Assert.IsNull(_edge8.Intersects(_edge6));
+
+      Assert.IsNotNull(_edge1.Intersects(_edge2));
+      Assert.AreEqual(_point6, _edge1.Intersects(_edge2));
+      Assert.IsNotNull(_edge5.Intersects(_edge5));
+      Assert.AreEqual(_point5, _edge5.Intersects(_edge6));
+      Assert.IsNotNull(_edge8.Intersects(_edge7));
+      Assert.AreEqual(_point4, _edge8.Intersects(_edge7));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestStaticIntersects() {
+      Assert.IsNull(Edge3D.Intersects(_edge1, _edge4));
+      Assert.IsNull(Edge3D.Intersects(_edge4, _edge1));
+      Assert.IsNull(Edge3D.Intersects(_edge7, _edge5));
+      Assert.IsNull(Edge3D.Intersects(_edge8, _edge6));
+      
+      Assert.IsNotNull(Edge3D.Intersects(new Edge3D(new Vector3D(0, 0, 0), new Vector3D(10, 0, 0)), new Edge3D(new Vector3D(0, 0, 0), new Vector3D(0, 10, 0))));
+      Assert.IsNotNull(Edge3D.Intersects(new Edge3D(new Vector3D(-10, 0, 0), new Vector3D(0, 0, 0)), new Edge3D(new Vector3D(0, -10, 0), new Vector3D(0, 0, 0))));
+
+      Assert.IsNotNull(Edge3D.Intersects(_edge1, _edge2));
+      Assert.AreEqual(_point6, Edge3D.Intersects(_edge1, _edge2));
+      Assert.IsNotNull(Edge3D.Intersects(_edge5, _edge5));
+      Assert.AreEqual(_point5, Edge3D.Intersects(_edge5, _edge6));
+      Assert.IsNotNull(Edge3D.Intersects(_edge8, _edge7));
+      Assert.AreEqual(_point4, Edge3D.Intersects(_edge8, _edge7));
+    }    
+  }
+}
+
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Line3DTest.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Line3DTest.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Line3DTest.cs	(revision 15554)
@@ -0,0 +1,112 @@
+﻿using System;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.BinPacking3D.Geometry;
+using HeuristicLab.Problems.BinPacking3D;
+
+namespace HeuristicLab.Problems.BinPacking._3D.Geometry.Test {
+  [TestClass]
+  public class Line3DTest {
+    Line3D _line1;
+    Line3D _line2;
+    Line3D _line3;
+    Line3D _line4;
+    Line3D _line5;
+    Line3D _line6;
+
+    Vector3D _point1;
+    Vector3D _point2;
+    Vector3D _point3;
+    Vector3D _point4;
+    Vector3D _point5;
+    Vector3D _point6;
+
+    Plane3D _plane1;
+    Plane3D _plane2;
+    Plane3D _plane3;
+
+    [TestInitialize]
+    public void Initialize() {
+      _line1 = new Line3D(new Vector3D(0, 0, 0), new Vector3D(10, 0, 0));
+      _line2 = new Line3D(new Vector3D(0, 0, 0), new Vector3D(0, 10, 0));
+      _line3 = new Line3D(new Vector3D(0, 0, 0), new Vector3D(0, 0, 10));
+
+      _line4 = new Line3D(new Vector3D(-10, 2, 2), new Vector3D(10, 0, 0));
+      _line5 = new Line3D(new Vector3D(2, -10, 2), new Vector3D(0, 10, 0));
+      _line6 = new Line3D(new Vector3D(2, 2, -10), new Vector3D(0, 0, 10));
+
+      _point1 = new Vector3D(3, 0, 0);
+      _point2 = new Vector3D(0, 3, 0);
+      _point3 = new Vector3D(0, 0, 3);
+
+      _point4 = new Vector3D(5, 5, 5);
+      _point5 = new Vector3D(2, 2, 2);
+      _point6 = new Vector3D(0, 0, 0);
+
+      _plane1 = new Plane3D(_point6.ToPackingPosition(0), new PackingItem(10, 10, 10, new PackingShape()), Side.Top);
+      _plane2 = new Plane3D(_point6.ToPackingPosition(0), new PackingItem(10, 10, 10, new PackingShape()), Side.Right);
+      _plane3 = new Plane3D(_point6.ToPackingPosition(0), new PackingItem(10, 10, 10, new PackingShape()), Side.Front);
+    }
+
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestIntersectsPlane() {
+      Assert.IsFalse(_line1.Intersects(_plane1));
+      Assert.IsTrue(_line2.Intersects(_plane1));
+      Assert.IsFalse(_line3.Intersects(_plane1));
+
+      Assert.IsTrue(_line1.Intersects(_plane2));
+      Assert.IsFalse(_line2.Intersects(_plane2));
+      Assert.IsFalse(_line3.Intersects(_plane2));
+
+      Assert.IsFalse(_line1.Intersects(_plane3));
+      Assert.IsFalse(_line2.Intersects(_plane3));
+      Assert.IsTrue(_line3.Intersects(_plane3));
+
+      Assert.IsTrue((new Line3D(new Vector3D(-1, -2, 2), new Vector3D(1, 3, 1))).Intersects(_plane1));
+      Assert.IsFalse((new Line3D(new Vector3D(-1, -2, 2), new Vector3D(-1, -3, 1))).Intersects(_plane1));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestIntersectPlane() {
+      Assert.IsNull(_line1.Intersect(_plane1));
+      Assert.AreEqual(new Vector3D(0, 10, 0), _line2.Intersect(_plane1));
+      Assert.IsNull(_line3.Intersect(_plane1));
+
+      Assert.AreEqual(new Vector3D(10, 0, 0), _line1.Intersect(_plane2));
+      Assert.IsNull(_line2.Intersect(_plane2));
+      Assert.IsNull(_line3.Intersect(_plane2));
+
+      Assert.IsNull(_line1.Intersect(_plane3));
+      Assert.IsNull(_line2.Intersect(_plane3));
+      Assert.AreEqual(new Vector3D(0, 0, 10), _line3.Intersect(_plane3));
+      Assert.AreEqual(new Vector3D(3, 10, 6), (new Line3D(new Vector3D(-1, -2, 2), new Vector3D(1, 3, 1))).Intersect(_plane1));
+      Assert.IsNull((new Line3D(new Vector3D(-1, -2, 2), new Vector3D(-1, -3, 1))).Intersect(_plane1));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestIntersectLine() {
+      Assert.IsNull(_line1.Intersect(_line4));
+      Assert.IsNull(_line1.Intersect(_line5));
+      Assert.IsNull(_line1.Intersect(_line6));
+
+      Assert.IsNotNull(_line1.Intersect(_line1));
+      Assert.IsNotNull(_line1.Intersect(_line2));
+      Assert.IsNotNull(_line1.Intersect(_line3));
+
+      Assert.IsNotNull(_line4.Intersect(_line5));
+      Assert.IsNotNull(_line4.Intersect(_line6));
+
+      Assert.IsTrue(_line1.Intersect(_line1).Equals(_point6));
+      Assert.IsTrue(_line1.Intersect(_line2).Equals(_point6));
+
+      Assert.IsTrue(_line4.Intersect(_line5).Equals(_point5));
+      Assert.IsTrue(_line4.Intersect(_line5).Equals(_point5));
+    }    
+  }
+}
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Plane3DTest.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Plane3DTest.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Plane3DTest.cs	(revision 15554)
@@ -0,0 +1,105 @@
+﻿using System;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.BinPacking3D.Geometry;
+using HeuristicLab.Problems.BinPacking3D;
+
+namespace HeuristicLab.Problems.BinPacking._3D.Geometry.Test {
+  [TestClass]
+  public class Plane3DTest {
+
+    Line3D _line1;
+    Line3D _line2;
+    Line3D _line3;
+    Line3D _line4;
+    Line3D _line5;
+    Line3D _line6;
+
+    Vector3D _point1;
+    Vector3D _point2;
+    Vector3D _point3;
+    Vector3D _point4;
+    Vector3D _point5;
+    Vector3D _point6;
+
+    Plane3D _plane1;
+    Plane3D _plane2;
+    Plane3D _plane3;
+
+    [TestInitialize]
+    public void Initialize() {
+      _line1 = new Line3D(new Vector3D(0, 0, 0), new Vector3D(10, 0, 0));
+      _line2 = new Line3D(new Vector3D(0, 0, 0), new Vector3D(0, 10, 0));
+      _line3 = new Line3D(new Vector3D(0, 0, 0), new Vector3D(0, 0, 10));
+
+      _line4 = new Line3D(new Vector3D(-10, 2, 2), new Vector3D(10, 0, 0));
+      _line5 = new Line3D(new Vector3D(2, -10, 2), new Vector3D(0, 10, 0));
+      _line6 = new Line3D(new Vector3D(2, 2, -10), new Vector3D(0, 0, 10));
+
+      _point1 = new Vector3D(3, 0, 0);
+      _point2 = new Vector3D(0, 3, 0);
+      _point3 = new Vector3D(0, 0, 3);
+
+      _point4 = new Vector3D(5, 5, 5);
+      _point5 = new Vector3D(2, 2, 2);
+      _point6 = new Vector3D(0, 0, 0);
+
+      _plane1 = new Plane3D(_point6.ToPackingPosition(0), new PackingItem(10, 10, 10, new PackingShape()), Side.Top);
+      _plane2 = new Plane3D(_point6.ToPackingPosition(0), new PackingItem(10, 10, 10, new PackingShape()), Side.Right);
+      _plane3 = new Plane3D(_point6.ToPackingPosition(0), new PackingItem(10, 10, 10, new PackingShape()), Side.Front);
+    }
+
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestIsElementOf() {
+      Assert.IsTrue(_plane1.IsElementOf(new Vector3D(0, 10, 0)));
+      Assert.IsTrue(_plane1.IsElementOf(new Vector3D(5, 10, 0)));
+      Assert.IsTrue(_plane1.IsElementOf(new Vector3D(0, 10, 5)));
+      Assert.IsTrue(_plane1.IsElementOf(new Vector3D(5, 10, 5)));
+      Assert.IsFalse(_plane1.IsElementOf(new Vector3D(0, 9, 0)));
+      Assert.IsFalse(_plane1.IsElementOf(new Vector3D(0, 11, 0)));
+    }
+
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestIntersects() {
+      Assert.IsFalse(_plane1.Intersects(_line1));
+      Assert.IsTrue(_plane1.Intersects(_line2));
+      Assert.IsFalse(_plane1.Intersects(_line3));
+
+      Assert.IsTrue(_plane2.Intersects(_line1));
+      Assert.IsFalse(_plane2.Intersects(_line2));
+      Assert.IsFalse(_plane2.Intersects(_line3));
+
+      Assert.IsFalse(_plane3.Intersects(_line1));
+      Assert.IsFalse(_plane3.Intersects(_line2));
+      Assert.IsTrue(_plane3.Intersects(_line3));
+
+      Assert.IsTrue(_plane1.Intersects(new Line3D(new Vector3D(-1, -2, 2), new Vector3D(1, 3, 1))));
+      Assert.IsFalse(_plane1.Intersects(new Line3D(new Vector3D(-1, -2, 2), new Vector3D(-1, -3, 1))));
+    }
+
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestIntersect() {
+      Assert.IsNull(_plane1.Intersect(_line1));
+      Assert.AreEqual(new Vector3D(0, 10, 0), _plane1.Intersect(_line2));
+      Assert.IsNull(_plane1.Intersect(_line3));
+
+      Assert.AreEqual(new Vector3D(10, 0, 0), _plane2.Intersect(_line1));
+      Assert.IsNull(_plane2.Intersect(_line2));
+      Assert.IsNull(_plane2.Intersect(_line3));
+
+      Assert.IsNull(_plane3.Intersect(_line1));
+      Assert.IsNull(_plane3.Intersect(_line2));
+      Assert.AreEqual(new Vector3D(0, 0, 10), _plane3.Intersect(_line3));
+      Assert.AreEqual(new Vector3D(3, 10, 6), _plane1.Intersect(new Line3D(new Vector3D(-1, -2, 2), new Vector3D(1, 3, 1))));
+      Assert.IsNull(_plane1.Intersect(new Line3D(new Vector3D(-1, -2, 2), new Vector3D(-1, -3, 1))));
+    }
+  }
+}
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Vector3DTest.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Vector3DTest.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Geometry/Vector3DTest.cs	(revision 15554)
@@ -0,0 +1,206 @@
+﻿using System;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.BinPacking3D.Geometry;
+using HeuristicLab.Problems.BinPacking3D;
+
+namespace HeuristicLab.Problems.BinPacking._3D.Geometry.Test {
+  [TestClass]
+  public class Vector3DTest {
+
+    Vector3D _point1;
+    Vector3D _point2;
+    Vector3D _point3;
+    Vector3D _point4;
+    Vector3D _point5;
+    Vector3D _point6;
+
+    PackingItem _item1;
+    PackingItem _item2;
+    PackingItem _item3;
+
+    [TestInitialize]
+    public void Initialize() {
+      _point1 = new Vector3D(3, 0, 0);
+      _point2 = new Vector3D(0, 3, 0);
+      _point3 = new Vector3D(0, 0, 3);
+
+      _point4 = new Vector3D(5, 5, 5);
+      _point5 = new Vector3D(2, 2, 2);
+      _point6 = new Vector3D(0, 0, 0);
+
+      _item1 = new PackingItem(10, 10, 10, new PackingShape());
+      _item2 = new PackingItem(20, 20, 20, new PackingShape());
+      _item3 = new PackingItem(30, 30, 30, new PackingShape());
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestAlongX() {
+      Assert.AreEqual(new Vector3D(13, 0, 0) ,Vector3D.AlongX(_point1.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(23, 0, 0), Vector3D.AlongX(_point1.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(33, 0, 0), Vector3D.AlongX(_point1.ToPackingPosition(0), _item3));
+
+
+      Assert.AreEqual(new Vector3D(10, 3, 0), Vector3D.AlongX(_point2.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(20, 3, 0), Vector3D.AlongX(_point2.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(30, 3, 0), Vector3D.AlongX(_point2.ToPackingPosition(0), _item3));
+
+      Assert.AreEqual(new Vector3D(10, 0, 3), Vector3D.AlongX(_point3.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(20, 0, 3), Vector3D.AlongX(_point3.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(30, 0, 3), Vector3D.AlongX(_point3.ToPackingPosition(0), _item3));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestAlongY() {
+      Assert.AreEqual(new Vector3D(3, 10, 0), Vector3D.AlongY(_point1.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(3, 20, 0), Vector3D.AlongY(_point1.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(3, 30, 0), Vector3D.AlongY(_point1.ToPackingPosition(0), _item3));
+
+
+      Assert.AreEqual(new Vector3D(0, 13, 0), Vector3D.AlongY(_point2.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(0, 23, 0), Vector3D.AlongY(_point2.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(0, 33, 0), Vector3D.AlongY(_point2.ToPackingPosition(0), _item3));
+
+      Assert.AreEqual(new Vector3D(0, 10, 3), Vector3D.AlongY(_point3.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(0, 20, 3), Vector3D.AlongY(_point3.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(0, 30, 3), Vector3D.AlongY(_point3.ToPackingPosition(0), _item3));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestAlongZ() {
+      Assert.AreEqual(new Vector3D(3, 0, 10), Vector3D.AlongZ(_point1.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(3, 0, 20), Vector3D.AlongZ(_point1.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(3, 0, 30), Vector3D.AlongZ(_point1.ToPackingPosition(0), _item3));
+
+
+      Assert.AreEqual(new Vector3D(0, 3, 10), Vector3D.AlongZ(_point2.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(0, 3, 20), Vector3D.AlongZ(_point2.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(0, 3, 30), Vector3D.AlongZ(_point2.ToPackingPosition(0), _item3));
+
+      Assert.AreEqual(new Vector3D(0, 0, 13), Vector3D.AlongZ(_point3.ToPackingPosition(0), _item1));
+      Assert.AreEqual(new Vector3D(0, 0, 23), Vector3D.AlongZ(_point3.ToPackingPosition(0), _item2));
+      Assert.AreEqual(new Vector3D(0, 0, 33), Vector3D.AlongZ(_point3.ToPackingPosition(0), _item3));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestCross() {
+      Assert.AreEqual(new Vector3D(0, 0, 9), _point1.Cross(_point2));
+      Assert.AreEqual(new Vector3D(0, 0, -9), _point2.Cross(_point1));
+      Assert.AreEqual(new Vector3D(9, 0, 0), _point2.Cross(_point3));
+      Assert.AreEqual(new Vector3D(-9, 0, 0), _point3.Cross(_point2));
+      Assert.AreEqual(new Vector3D(0, -9, 0), _point1.Cross(_point3));
+      Assert.AreEqual(new Vector3D(0, 9, 0), _point3.Cross(_point1));
+
+
+      Assert.AreEqual(new Vector3D(0, -15, 15), _point1.Cross(_point4));
+      Assert.AreEqual(new Vector3D(15, 0, -15), _point2.Cross(_point4));
+      Assert.AreEqual(new Vector3D(-15, 15, 0), _point3.Cross(_point4));
+
+      Assert.AreEqual(new Vector3D(0, 15, -15), _point4.Cross(_point1));
+      Assert.AreEqual(new Vector3D(-15, 0, 15), _point4.Cross(_point2));
+      Assert.AreEqual(new Vector3D(15, -15, 0), _point4.Cross(_point3));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestIsInside() {
+      Assert.IsFalse(_point1.IsInside(_point4.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsFalse(_point2.IsInside(_point4.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsFalse(_point3.IsInside(_point4.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+
+      Assert.IsTrue(_point1.IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsTrue(_point2.IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsTrue(_point3.IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsTrue(_point6.IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+
+      Assert.IsTrue(_point4.IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsTrue(_point5.IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsTrue((new Vector3D(9, 9, 9)).IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsFalse((new Vector3D(11, 9, 9)).IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsFalse((new Vector3D(9, 11, 9)).IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+      Assert.IsFalse((new Vector3D(9, 9, 11)).IsInside(_point6.ToPackingPosition(0), ResidualSpace.Create(10, 10, 10)));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestOperators() {
+      // static int operator *(Vector3D a, Vector3D b) 
+      Assert.AreEqual(0, (_point1 * _point2));
+      Assert.AreEqual(0, (_point2 * _point1));
+      Assert.AreEqual(0, (_point4 * _point6));
+      Assert.AreEqual(0, (_point6 * _point4));
+      Assert.AreEqual(15, (_point1 * _point4));
+      Assert.AreEqual(15, (_point4 * _point1));
+      Assert.AreEqual(30, (_point5 * _point4));
+      Assert.AreEqual(30, (_point4 * _point5));
+
+      // static Vector3D operator *(int a, Vector3D b), static Vector3D operator *(Vector3D a, int b)
+      Assert.AreEqual(new Vector3D(3, 0, 0), 1 * _point1);
+      Assert.AreEqual(new Vector3D(6, 0, 0), 2 * _point1);
+      Assert.AreEqual(new Vector3D(3, 0, 0), _point1 * 1);
+      Assert.AreEqual(new Vector3D(6, 0, 0), _point1 * 2);
+      Assert.AreEqual(2 * _point1, _point1 * 2);
+
+      Assert.AreEqual(new Vector3D(9, 0, 0), _point1 * 3);
+      Assert.AreEqual(new Vector3D(0, 9, 0), _point2 * 3);
+      Assert.AreEqual(new Vector3D(0, 0, 9), _point3 * 3);
+
+      Assert.AreEqual(new Vector3D(20, 20, 20), 4 * _point4);
+      Assert.AreEqual(new Vector3D(20, 20, 20), _point4 * 4);      
+      Assert.AreEqual(4 * _point4, _point4 * 4);
+
+      // static Vector3D operator *(double a, Vector3D b), static Vector3D operator *(Vector3D a, double b)
+      Assert.AreEqual(new Vector3D(3, 0, 0), 1.1 * _point1);
+      Assert.AreEqual(new Vector3D(6, 0, 0), 2.2 * _point1);
+      Assert.AreEqual(new Vector3D(3, 0, 0), _point1 * 1.1);
+      Assert.AreEqual(new Vector3D(6, 0, 0), _point1 * 2.2);
+      Assert.AreEqual(2.2 * _point1, _point1 * 2.2);
+      
+      Assert.AreEqual(new Vector3D(9, 0, 0), _point1 * 3.3);
+      Assert.AreEqual(new Vector3D(0, 9, 0), _point2 * 3.3);
+      Assert.AreEqual(new Vector3D(0, 0, 9), _point3 * 3.3);
+
+      Assert.AreEqual(new Vector3D(22, 22, 22), 4.4 * _point4);
+      Assert.AreEqual(new Vector3D(22, 22, 22), _point4 * 4.4);
+      Assert.AreEqual(4.4 * _point4, _point4 * 4.4);
+
+      // static Vector3D operator +(Vector3D a, Vector3D b)
+      Assert.AreEqual(new Vector3D(8, 5, 5), _point1 + _point4);
+      Assert.AreEqual(new Vector3D(5, 8, 5), _point2 + _point4);
+      Assert.AreEqual(new Vector3D(5, 5, 8), _point3 + _point4);
+      Assert.AreEqual(new Vector3D(7, 7, 7), _point4 + _point5);
+      Assert.AreEqual(_point4, _point4 + _point6);
+
+      // static Vector3D operator -(Vector3D a, Vector3D b)
+      Assert.AreEqual(new Vector3D(-2, -5, -5), _point1 - _point4);
+      Assert.AreEqual(new Vector3D(-5, -2, -5), _point2 - _point4);
+      Assert.AreEqual(new Vector3D(-5, -5, -2), _point3 - _point4);
+      Assert.AreEqual(new Vector3D(3, 3, 3), _point4 - _point5);
+      Assert.AreEqual(_point4, _point4 - _point6);
+
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestEquals() {
+      Assert.IsFalse(_point1.Equals(_point2));
+      Assert.IsFalse(_point1.Equals(new Vector3D(3, 0, 1)));
+      Assert.IsFalse(_point1.Equals(new Vector3D(3, 1, 0)));
+      Assert.IsFalse(_point1.Equals(new Vector3D(2, 0, 0)));
+
+      Assert.IsTrue(_point1.Equals(_point1));
+      Assert.IsTrue(_point5.Equals(new Vector3D(2, 2, 2)));
+    }
+    
+  }
+}
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Instances/ThreeDInstanceParserTest.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Instances/ThreeDInstanceParserTest.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Instances/ThreeDInstanceParserTest.cs	(revision 15554)
@@ -0,0 +1,101 @@
+﻿using System;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using System.IO;
+using HeuristicLab.Problems.BinPacking3D.Instances;
+using System.Collections.Generic;
+using HeuristicLab.Problems.BinPacking3D;
+
+namespace HeuristicLab.Problems.BinPacking._3D.Instances.Tests {
+  [TestClass]
+  public class ThreeDInstanceParserTest {
+    private PackingShape _packingShape;
+    private IList<PackingItem> _items1;
+    private IList<PackingItem> _items2;
+
+    [TestInitialize]
+    public void Initializes() {
+      _packingShape = new PackingShape(22, 23, 21);
+      _items1 = new List<PackingItem>();
+
+      _items1.Add(new PackingItem(8, 10, 10, _packingShape, 800, 1)); // 0,  V = 800,  A =  80, h = 10
+      _items1.Add(new PackingItem(10, 8, 10, _packingShape, 800, 2)); // 1,  V = 800,  A = 100, h =  8
+      _items1.Add(new PackingItem(10, 10, 8, _packingShape, 800, 3)); // 2,  V = 800,  A =  80, h = 10
+      _items1.Add(new PackingItem(8, 8, 10,  _packingShape, 640, 4)); // 3,   V = 640,  A =  80, h =  8
+      _items1.Add(new PackingItem(10, 8, 8,  _packingShape, 640, 0)); // 4,   V = 640,  A =  80, h =  8
+      _items1.Add(new PackingItem(8, 10, 8,  _packingShape, 640, 1)); // 5,   V = 640,  A =  64, h = 10  
+      _items1.Add(new PackingItem(8, 8, 8,   _packingShape, 512, 2)); // 6,    V = 512,  A =  64, h =  8
+
+      _items1.Add(new PackingItem(10, 10, 10, _packingShape,1000,3)); // 7, V = 1000, A = 100, h = 10
+
+      _items1.Add(new PackingItem(9, 10, 10, _packingShape, 900, 4)); // 8,  V = 900,  A =  90, h = 10
+      _items1.Add(new PackingItem(10, 9, 10, _packingShape, 900, 0)); // 9,  V = 900,  A = 100, h =  9
+      _items1.Add(new PackingItem(10, 10, 9, _packingShape, 900, 1)); // 10, V = 900,  A =  90, h = 10
+      _items1.Add(new PackingItem(9, 9, 10,  _packingShape, 810, 2)); // 11,  V = 810,  A =  90, h =  9
+      _items1.Add(new PackingItem(10, 9, 9,  _packingShape, 810, 3)); // 12,  V = 810,  A =  90, h =  9
+      _items1.Add(new PackingItem(9, 10, 9,  _packingShape, 810, 4)); // 13,  V = 810,  A =  81, h = 10
+      _items1.Add(new PackingItem(9, 9, 9,   _packingShape, 729, 0)); // 14,   V = 729,  A =  81, h =  9
+
+      _items2 = new List<PackingItem>();
+      _items2.Add(new PackingItem(8, 10, 10, _packingShape, 800, 1)); // 0,  V = 800,  A =  80, h = 10
+      _items2.Add(new PackingItem(10, 8, 10, _packingShape, 800, 2)); // 1,  V = 800,  A = 100, h =  8
+      _items2.Add(new PackingItem(10, 10, 8, _packingShape, 800, 3)); // 2,  V = 800,  A =  80, h = 10
+      _items2.Add(new PackingItem(8, 8, 10, _packingShape, 640, 4)); // 3,   V = 640,  A =  80, h =  8
+      _items2.Add(new PackingItem(10, 8, 8, _packingShape, 640, 0)); // 4,   V = 640,  A =  80, h =  8
+      _items2.Add(new PackingItem(8, 10, 8, _packingShape, 640, 1)); // 5,   V = 640,  A =  64, h = 10  
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestParse() {
+      string path = @".\..\HeuristicLab.Tests\HeuristicLab.Problems.Bin-Packing-3.3\TestInstances\Parser\3D-UnitTestParser1.txt";
+      ThreeDInstanceParser parser = new ThreeDInstanceParser();
+
+      using (var fileStream = File.Open(path, FileMode.Open)) {
+        parser.Parse(fileStream);
+      }
+      
+      Assert.AreEqual(_packingShape.Width, parser.Bin.Width);
+      Assert.AreEqual(_packingShape.Height, parser.Bin.Height);
+      Assert.AreEqual(_packingShape.Depth, parser.Bin.Depth);
+
+      Assert.AreEqual(_items1.Count, parser.Items.Count);
+      for (int i = 0; i < parser.Items.Count; i++) {
+        PackingItem expected = _items1[i];
+        PackingItem actual = parser.Items[i];
+        Assert.AreEqual(expected.Width, actual.Width);
+        Assert.AreEqual(expected.Height, actual.Height);
+        Assert.AreEqual(expected.Depth, actual.Depth);
+        Assert.AreEqual(expected.Material, actual.Material);
+        Assert.AreEqual(expected.Weight, actual.Weight);
+      }
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestParseUncompleteFile() {
+      string path = @".\..\HeuristicLab.Tests\HeuristicLab.Problems.Bin-Packing-3.3\TestInstances\Parser\3D-UnitTestParser2.txt";
+      ThreeDInstanceParser parser = new ThreeDInstanceParser();
+
+      using (var fileStream = File.Open(path, FileMode.Open)) {
+        parser.Parse(fileStream);
+      }
+
+      Assert.AreEqual(_packingShape.Width, parser.Bin.Width);
+      Assert.AreEqual(_packingShape.Height, parser.Bin.Height);
+      Assert.AreEqual(_packingShape.Depth, parser.Bin.Depth);
+
+      Assert.AreEqual(_items2.Count, parser.Items.Count);
+      for (int i = 0; i < parser.Items.Count; i++) {
+        PackingItem expected = _items2[i];
+        PackingItem actual = parser.Items[i];
+        Assert.AreEqual(expected.Width, actual.Width);
+        Assert.AreEqual(expected.Height, actual.Height);
+        Assert.AreEqual(expected.Depth, actual.Depth);
+        Assert.AreEqual(expected.Material, actual.Material);
+        Assert.AreEqual(expected.Weight, actual.Weight);
+      }
+    }
+  }
+}
